"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const graphql_codegen_visitor_plugin_common_1 = require("graphql-codegen-visitor-plugin-common");
class FieldsTree {
    constructor() {
        this._fields = {};
    }
    addField(path, type) {
        lodash_1.set(this._fields, path, type);
    }
    _getInnerField(root, level = 1) {
        if (typeof root === 'string') {
            return root;
        }
        const fields = Object.keys(root).map(fieldName => {
            const fieldValue = root[fieldName];
            return graphql_codegen_visitor_plugin_common_1.indent(`${fieldName}: ${this._getInnerField(fieldValue, level + 1)},`, level);
        });
        return level === 1
            ? fields.join('\n')
            : `{
${fields.join('\n')}
${graphql_codegen_visitor_plugin_common_1.indent('}', level - 1)}`;
    }
    get string() {
        return this._getInnerField(this._fields);
    }
}
exports.FieldsTree = FieldsTree;
//# sourceMappingURL=fields-tree.js.map